/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumDatatype;
import de.ship.db.tables.records.VInputTypeDeDeRecord;

import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VInputTypeDeDe extends TableImpl<VInputTypeDeDeRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_input_type_de_de</code>
     */
    public static final VInputTypeDeDe V_INPUT_TYPE_DE_DE = new VInputTypeDeDe();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VInputTypeDeDeRecord> getRecordType() {
        return VInputTypeDeDeRecord.class;
    }

    /**
     * The column <code>common_dd.v_input_type_de_de.lastchange</code>.
     */
    public final TableField<VInputTypeDeDeRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_input_type_de_de.pk</code>.
     */
    public final TableField<VInputTypeDeDeRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_input_type_de_de.has_valuelist</code>.
     */
    public final TableField<VInputTypeDeDeRecord, Boolean> HAS_VALUELIST = createField(DSL.name("has_valuelist"), SQLDataType.BOOLEAN, this, "");

    /**
     * The column <code>common_dd.v_input_type_de_de.data_type</code>.
     */
    public final TableField<VInputTypeDeDeRecord, EnumDatatype> DATA_TYPE = createField(DSL.name("data_type"), SQLDataType.VARCHAR.asEnumDataType(EnumDatatype.class), this, "");

    /**
     * The column <code>common_dd.v_input_type_de_de.inputtype_descr</code>.
     */
    public final TableField<VInputTypeDeDeRecord, String> INPUTTYPE_DESCR = createField(DSL.name("inputtype_descr"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_input_type_de_de.lang_value</code>.
     */
    public final TableField<VInputTypeDeDeRecord, String> LANG_VALUE = createField(DSL.name("lang_value"), SQLDataType.CLOB, this, "");

    private VInputTypeDeDe(Name alias, Table<VInputTypeDeDeRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VInputTypeDeDe(Name alias, Table<VInputTypeDeDeRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_input_type_de_de" as  SELECT v_input_type.lastchange,
          v_input_type.pk,
          v_input_type.has_valuelist,
          v_input_type.data_type,
          v_input_type.inputtype_descr,
          t_core_translation.value AS lang_value
         FROM (common_dd.v_input_type
           LEFT JOIN common_dd.t_core_translation ON (((t_core_translation.fk_trans_key = v_input_type.inputtype_descr) AND (t_core_translation.isocode = 'de_DE'::common_dd.enum_isocode) AND (t_core_translation.category = 'crf'::common_dd.enum_trans_category))))
        ORDER BY v_input_type.pk;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_input_type_de_de</code> table
     * reference
     */
    public VInputTypeDeDe(String alias) {
        this(DSL.name(alias), V_INPUT_TYPE_DE_DE);
    }

    /**
     * Create an aliased <code>common_dd.v_input_type_de_de</code> table
     * reference
     */
    public VInputTypeDeDe(Name alias) {
        this(alias, V_INPUT_TYPE_DE_DE);
    }

    /**
     * Create a <code>common_dd.v_input_type_de_de</code> table reference
     */
    public VInputTypeDeDe() {
        this(DSL.name("v_input_type_de_de"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VInputTypeDeDe as(String alias) {
        return new VInputTypeDeDe(DSL.name(alias), this);
    }

    @Override
    public VInputTypeDeDe as(Name alias) {
        return new VInputTypeDeDe(alias, this);
    }

    @Override
    public VInputTypeDeDe as(Table<?> alias) {
        return new VInputTypeDeDe(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputTypeDeDe rename(String name) {
        return new VInputTypeDeDe(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputTypeDeDe rename(Name name) {
        return new VInputTypeDeDe(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VInputTypeDeDe rename(Table<?> name) {
        return new VInputTypeDeDe(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe where(Condition condition) {
        return new VInputTypeDeDe(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputTypeDeDe where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputTypeDeDe where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputTypeDeDe where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VInputTypeDeDe where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VInputTypeDeDe whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
